import jp.ac.takushoku_u.cs.*;

/**
* MathEdge饹Υƥȥ饹<br>
* ¹ԤˤLFTAnalysis饹ɬפǤ
* @version 1.1
* @author  ͵(Kasajima Hiroshi)
*/
/*
* ǽ 2005ǯ0110
*/
class MathEdgeTest{

public static void main(String[] args){

	boolean[][] sampleData = { //ԤΥޥȥꥯǡ
		    {false,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{false,true,true,true,false,false,false,false,false},
			{false,false,false,false,true,false,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,true,true,false}};
	
		boolean[][] sampleData2 = { //ؽԤΥޥȥꥯǡ (7,6)ʤ
		    {false,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{false,true,true,true,false,false,false,false,false},
			{false,false,false,false,true,false,false,false,false},
			{false,false,false,false,false,false,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,true,true,false}};
	
	String[] name = {"1","2","3","4","5","6","7","8","9"};
	
	//ޥȥꥯ
	BooleanMatrix dataMatrix = new BooleanMatrix(sampleData, name, name);
	BooleanMatrix dataMatrix2 = new BooleanMatrix(sampleData2, name, name);
	
	//LFTʬϤԤ
	LFTAnalysis result = new LFTAnalysis(dataMatrix, dataMatrix2);
	
	//ޥȥꥯ(6,5)н򽸹ȤƽϤ(setA)
	EdgeSet hashSet = new EdgeSet();
	hashSet = result.getElementPairSet(dataMatrix, 
		dataMatrix.getRowNumber("6"), dataMatrix.getColNumber("5"));
	Object o[] = new Object[hashSet.size()];
	Edge d[] = new Edge[hashSet.size()];
	o = hashSet.toArray();
	System.out.println("setA:(6,5)н");
	//Ǥν
    for(int i = 0; i < hashSet.size(); i++){
    	d[i] = (Edge)o[i];
    	System.out.print("("+(d[i].getBegin()+1)+","+(d[i].getEnd()+1)+"),");
    }
	
	System.out.println();
	System.out.println("ǿ: "+hashSet.size());
	System.out.println();
	
	//ޥȥꥯ(5,4)н򽸹ȤƽϤ(setB)
	EdgeSet hSet = new EdgeSet();
	hSet = result.getElementPairSet(dataMatrix, 
		dataMatrix.getRowNumber("5"), dataMatrix.getColNumber("4"));
	Object op[] = new Object[hSet.size()];
	Edge de[] = new Edge[hSet.size()];
	op = hSet.toArray();
	System.out.println("setB:(5,4)н");
    for(int i = 0; i < hSet.size(); i++){
    	de[i] = (Edge)op[i];
    	System.out.print("("+(de[i].getBegin()+1)+","+(de[i].getEnd()+1)+"),");
    }
	
	System.out.println();
	System.out.println("ǿ: "+hSet.size());
	System.out.println();
	
	
	//Ѥ
	EdgeSet rSet = MathEdge.getAndEdge(hashSet, hSet);
	Object p[] = new Object[rSet.size()];
	Edge e[] = new Edge[rSet.size()];
	p = rSet.toArray();
	System.out.println("ѽ");
	//Ǥν
    for(int i = 0; i < rSet.size(); i++){
    	e[i] = (Edge)p[i];
    	System.out.print("("+(e[i].getBegin()+1)+","+(e[i].getEnd()+1)+"),");
    }
	System.out.println();
	//ǿν
	System.out.println("ǿ: "+rSet.size());
	System.out.println();
	
	//¤
	EdgeSet sSet = MathEdge.getOrEdge(hashSet, hSet);
	Object q[] = new Object[sSet.size()];
	Edge f[] = new Edge[sSet.size()];
	q = sSet.toArray();
	System.out.println("½");
    for(int i = 0; i < sSet.size(); i++){
    	f[i] = (Edge)q[i];
    	System.out.print("("+(f[i].getBegin()+1)+","+(f[i].getEnd()+1)+"),");
    }
	System.out.println();
	System.out.println("ǿ: "+sSet.size());
	System.out.println();
	
	//(setA - setB)
	EdgeSet tSet = MathEdge.getSubEdge(hashSet, hSet);
	Object r[] = new Object[tSet.size()];
	Edge g[] = new Edge[tSet.size()];
	r = tSet.toArray();
	System.out.println("setAκ");
    for(int i = 0; i < tSet.size(); i++){
    	g[i] = (Edge)r[i];
    	System.out.print("("+(g[i].getBegin()+1)+","+(g[i].getEnd()+1)+"),");
    }
	System.out.println();
	System.out.println("ǿ: "+tSet.size());
	System.out.println();
	
	//(setB - setA)
	EdgeSet tbSet = MathEdge.getSubEdge(hSet, hashSet);
	Object rb[] = new Object[tSet.size()];
	Edge gb[] = new Edge[tSet.size()];
	rb = tbSet.toArray();
	System.out.println("setBκ");
    for(int i = 0; i < tbSet.size(); i++){
    	gb[i] = (Edge)rb[i];
    	System.out.print("("+(gb[i].getBegin()+1)+","+(gb[i].getEnd()+1)+"),");
    }
	System.out.println();
	System.out.println("ǿ: "+tbSet.size());
	System.out.println();
	
	//¾Ū¤
	EdgeSet uSet = MathEdge.getXOrEdge(hashSet, hSet);
	Object s[] = new Object[uSet.size()];
	Edge h[] = new Edge[uSet.size()];
	s = uSet.toArray();
	System.out.println("¾Ū");
    for(int i = 0; i < uSet.size(); i++){
    	h[i] = (Edge)s[i];
    	System.out.print("("+(h[i].getBegin()+1)+","+(h[i].getEnd()+1)+"),");
    }
	System.out.println();
	System.out.println("ǿ: "+uSet.size());
	System.out.println();
	
}
	
/**
* ޥȥꥯintɸϤ˽Ϥޤ
* @param outMatrix Ϥ٤ޥȥꥯ
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* ޥȥꥯdoubleɸϤ˽Ϥޤ
* @param outMatrix Ϥ٤ޥȥꥯ
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.000");		//ʲ3ޤǽ
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + " ");		//̾
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//̾
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+" ");
				}
			}
		}
		System.out.println();
	}
	
/**
* ޥȥꥯbooleanɸϤ˽Ϥޤ
*/
	private static void outputMatrix(BooleanMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(" "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print(" "+outMatrix.getCell(i, j));
					if(outMatrix.getCell(i, j)){
						System.out.print(" ");
					}
				}
			}
		}
		System.out.println();
	}
	
/**
* StringMatrixɸϤ˽Ϥޤ
* @param outMatrix Ϥ٤ޥȥꥯ
*/
	private static void outputMatrix(StringMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
}
